<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="用户id" prop="pushId">
        <el-input
          v-model="queryParams.pushId"
          placeholder="请输入用户id"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="月嫂id" prop="targetId">
        <el-input
          v-model="queryParams.targetId"
          placeholder="请输入月嫂id"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="用户类型" prop="pushType">
        <el-select
          v-model="queryParams.pushType"
          placeholder="请选择用户类型"
          clearable
          class="!w-240px"
        >
          <el-option label="用户侧" :value="101" />
          <el-option label="月嫂侧" :value="100" />
        </el-select>
      </el-form-item>
      <el-form-item label="投诉类型" prop="suggestionType">
        <el-select
          v-model="queryParams.suggestionType"
          placeholder="请选择投诉类型"
          clearable
          class="!w-240px"
        >
          <el-option label="订单投诉" :value="0" />
          <el-option label="首页投诉" :value="1" />
          <el-option label="聊天投诉" :value="2" />
        </el-select>
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['yuesao:suggestion:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['yuesao:suggestion:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="投诉id" align="center" prop="id" />
      <el-table-column label="用户id" align="center" prop="pushId" />
      <el-table-column label="月嫂id" align="center" prop="targetId" />
      <el-table-column label="用户类型" align="center" prop="pushType">
        <template #default="{ row }">
          {{ row.pushType === 101 ? '用户侧' : '月嫂侧' }}
        </template>
      </el-table-column>
      <el-table-column label="留言内容" align="center" prop="comment" />
      <el-table-column label="投诉类型" align="center" prop="suggestionType">
        <template #default="{ row }">
          {{ config.find((item) => item.id === row.suggestionType)?.label }}
        </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="state">
        <template #default="{ row }">
          <el-tag>{{ stateConf.find((item) => item.id === row.state)?.label }}</el-tag>
        </template>
      </el-table-column>
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" align="center" fixed="right" min-width="200">
        <template #default="scope">
          <el-popconfirm v-if="scope.row.state === 0" title="是否通过？" width="250px" @confirm="onResolve(scope.row)">
            <template #reference>
              <el-button link type="danger">通过</el-button>
            </template>
          </el-popconfirm>
          <el-popconfirm v-if="scope.row.state === 0" title="是否拒绝？" width="250px" @confirm="onReject(scope.row)">
            <template #reference>
              <el-button link type="danger">拒绝</el-button>
            </template>
          </el-popconfirm>
          <el-button v-if="scope.row.suggestionType === 0" link type="primary" @click="gotoOrder(scope.row.cheatContentIds)">查看订单</el-button>
          <el-button v-if="scope.row.suggestionType === 2" link type="primary" @click="openRecord(scope.row)">查看聊天记录</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <SuggestionForm ref="formRef" @success="getList" />
  <MessageRecord ref="recordRef" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import * as SuggestionApi from '@/api/suggestion'
import SuggestionForm from './SuggestionForm.vue'
import MessageRecord from './MessageRecord.vue';
import { SuggestionVO } from '@/api/suggestion';
import router from '@/router';

defineOptions({ name: 'Suggestion' })

const message = useMessage() // 消息弹窗
const route = useRoute()

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  pushId: undefined,
  targetId: undefined,
  pushType: undefined,
  comment: undefined,
  suggestionType: undefined,
  createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

const config = [
  { id: 0, label: '订单投诉' },
  { id: 1, label: '首页投诉' },
  { id: 2, label: '聊天投诉' }
]

const stateConf = [
  { id: 0, label: '未操作' },
  { id: 1, label: '已通过' },
  { id: 2, label: '已拒绝' }
]

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await SuggestionApi.getSuggestionPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

const recordRef = ref()
const openRecord = (row: SuggestionVO) => {
  recordRef.value.open(row.id, row.pushType === 101 ? row.pushId : row.targetId, row.pushType === 101 ? row.targetId : row.pushId)
}

const gotoOrder = (id: number) => {
  router.push({ path: '/order/order', query: { id } })
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await SuggestionApi.exportSuggestion(queryParams)
    download.excel(data, '留言反馈.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

const onResolve = async (item: any) => {
  try {
    await SuggestionApi.updateFeedback({
      id: item.id,
      state: 1,
      pushId: item.pushId,
      pushType: item.pushType
    });
    message.success('修改成功')
    // 刷新列表
    await getList()
  } catch {}
}

const onReject = async (item: any) => {
  try {
    await SuggestionApi.updateFeedback({
      id: item.id,
      state: 2,
      pushId: item.pushId,
      pushType: item.pushType
    });
    message.success('修改成功')
    // 刷新列表
    await getList()
  } catch {}
}

/** 初始化 **/
onMounted(() => {
  if (route.query.userId) {
    // @ts-ignore
    queryParams.pushId = Number(route.query.userId);
  }
  if (route.query.yuesaoId) {
    // @ts-ignore
    queryParams.targetId = Number(route.query.yuesaoId);
  }
  getList()
})
</script>
